/*
 * Copyright (C) 2003-2007 eXo Platform SAS.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Affero General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see<http://www.gnu.org/licenses/>.
 */
package org.exoplatform.services.jcr.aws.storage.sdb;

/**
 * Created by The eXo Platform SAS.
 * 
 * <br/>Date: 10.10.2008
 * 
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: SDBValueNumberFormatException.java 21606 2008-10-20 10:44:09Z pnedonosko $
 */
public class SDBValueNumberFormatException extends NumberFormatException {

  /**
   * serialVersionUID.
   */
  private static final long serialVersionUID = 1571003452126509704L;

  /**
   * Cause exception.
   */
  private final Throwable   cause;

  /**
   * SDBValueNumberFormatException constructor.
   * 
   * @param message
   *          - error message.
   * @param cause
   *          - error cause.
   */
  SDBValueNumberFormatException(String message, Throwable cause) {
    super(message);
    this.cause = cause;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public Throwable getCause() {
    return this.cause;
  }

}
